/* 
 * File:   DateTime.h
 * Author: Henrik Thulin
 *
 * Created on den 5 april 2014, 00:26
 */

#ifndef DATETIME_H
#define	DATETIME_H

class DateTime {
public:
    struct DateTimeData {
        short year;
        char month;
        char day;
        char hour;
        char minute;
        char second;
    } dateTime;

    static bool IsLeap(DateTimeData dt);
    static unsigned char GetDayOfWeek(DateTimeData dt);
    static unsigned char GetDaysInMonth(DateTimeData dt);

    //DateTimeData dateTime;

    DateTime();
    DateTime(short year, char month, char day, char hour, char minute, char second);
    DateTime(DateTimeData dt);
    DateTime(const DateTime& orig);
    virtual ~DateTime();

    void AddHours(int hours);
    void AddDays(int days);
    bool Equals(DateTime* dt);
    void Copy(DateTime* source);

    DateTimeData GetDateTime();
    void SetDateTime(DateTimeData dt);
    bool IsSwedishSummerTime();

private:
    void AddHour();
    void AddDay();
};

#endif	/* DATETIME_H */

