/*
 * File:   main.c
 * Author: Rutger
 *
 * Created on den 11 januari 2014, 22:25
 */

//#pragma config FPLLIDIV = DIV_2, FPLLMUL = MUL_18, FPLLODIV = DIV_1, FWDTEN = OFF
//#pragma config POSCMOD = OFF, FNOSC = FRCPLL, FPBDIV = DIV_2

#pragma config FPLLIDIV = DIV_2
#pragma config FPLLODIV = DIV_1
#pragma config FPBDIV = DIV_1
#pragma config FWDTEN = OFF
#pragma config POSCMOD = HS
#pragma config FNOSC = PRIPLL
#pragma config FPLLMUL = MUL_18
#pragma config FSOSCEN = OFF
#pragma config OSCIOFNC = OFF // CLKO Output Signal Active on the OSCO Pin

#define SYS_FREQ (80000000L)

#define GetSystemClock()       (80000000L)
#define GetPeripheralClock()    (GetSystemClock())

#define ROWS 16
#define TIMEROW 2
#define DATEROW 9
#define STARTCOLUMN 2

//#pragma config FUSBIDIO = OFF
//#pragma config FVBUSONIO = OFF

#include <p32xxxx.h>
#include <plib.h>
#include "ds3232.h"
#include "DateTime.h"

//#include <stdio.h>
//#include <stdlib.h>
//#include <p32xxxx.h>
//#include <plib.h>

unsigned int cache[ROWS];
unsigned int prevcache[ROWS];

enum direction {
    up, down
};

char click = 0;

unsigned int second;

const unsigned short numbers[10] = {
    0b111101101101111, // 0
    0b001011001001001, // 1
    0b111001111100111, // 2
    0b111001111001111, // 3
    0b101101111001001, // 4
    0b111100111001111, // 5
    0b111100111101111, // 6
    0b111001001001001, // 7
    0b111101111101111, // 8
    0b111101111001001 // 9
};

const unsigned short letters[] = {
    0b111101111101101, // A
    0b111101110101111, // B
    0b111100100100111, // C
    0b110101101101110, // D
    0b111100110100111, // E
    0b111100110100100, // F
    0b111100100101111, // G
    0b101101111101101, // H
    0b010010010010010, // I
    0b111001001101111, // J
    0b101110100110101, // K
    0b100100100100111, // L
    0b111111101101101, // M
    0b111101101101101, // N
    0b111101101101111, // O
    0b111101111100100, // P
    0b111101101111111, // Q
    0b111101111110101, // R
    0b111100111001111, // S
    0b111010010010010, // T
    0b101101101101111, // U
    0b101101101101010, // V
    0b101101101111111, // W
    0b101101010101101, // X
    0b101101010010010, // Y
    0b111001111100111 // Z
};

const char* months[] = {"JAN ", "FEB ", "MAR ", "APR ", "MAY ", "JUN ", "JUL ", "AUG ", "SEP ", "OCT ", "NOV ", "DEC "};


/*union DS3232_OE {
    unsigned char data;
    struct
    {
        unsigned A1IE : 1;
        unsigned A2IE : 1;
        unsigned INTCN : 1;
        unsigned RS : 2;
        unsigned CONV : 1;
        unsigned BBSQW : 1;
        unsigned EOSC : 1;
    };
} DS3232_OE;*/



/*
 *
 */
//int main(int argc, char** argv) {


extern "C"
void SPI_Out(unsigned int c) {
    //int dummy;
    /*
    SPI1BUF = c;
    while(!SPI1STATbits.SPIRBF) Nop();
    dummy = SPI1BUF;                */
    SpiChnPutC(SPI_CHANNEL1, c);
    SpiChnGetC(SPI_CHANNEL1);
}

void SPI_Send(unsigned char moduleNumber, unsigned short c) {
    unsigned char d;

    LATBbits.LATB15 = 0;

    for (d = moduleNumber; d < 8; d++)
        SPI_Out(0x00);

    SPI_Out(c);

    for (d = 0; d < moduleNumber; d++)
        SPI_Out(0x00);

    LATBbits.LATB15 = 1;
    LATBbits.LATB15 = 0;
    //pause();
}

void SPI_SendRegData(unsigned char moduleNumber, unsigned char reg, unsigned char data) {
    //    unsigned short c = (unsigned short)(reg << 8 | data);
    SPI_Send(moduleNumber, (unsigned short) (reg << 8 | data));
}

void pause() {
    unsigned int i;
    for (i = 0; i < 0xfff; i++) Nop();
}

void pause2() {
    unsigned int i;
    for (i = 0; i < 0x1fff; i++) Nop();
}

void SetPixel(char x, char y, unsigned char on) {

    if (y >= ROWS || y < 0 || x < 0 || x > 31) return;

    unsigned char module;
    unsigned char xpos;
    unsigned char data;
    unsigned char move;

    unsigned int c;

    module = (x / 8);

    xpos = x % 8;

    c = cache[y];

    if (on)
        c = c | (0x80000000 >> x);
    else
        c = c & ~(0x80000000 >> x);

    cache[y] = c;

    move = 24 - (8 * (x / 8));

    data = (unsigned char) (c >> move);

    //SPI_SendRegData(module, 8 - y, data);
}

void SendToModules() {
    char c, y, data;

    for (y = 0; y < 8; y++)
        if (prevcache[y] != cache[y]) {
            for (c = 0; c < 4; c++) {
                if (cache[y] >> (24 - (c * 8)) != prevcache[y] >> (24 - (c * 8)))
                    SPI_SendRegData(c, 8 - y, (unsigned char) (cache[y] >> (24 - (c * 8))));
            }

            prevcache[y] = cache[y];
        }

    for (y = 8; y < 16; y++)
        if (prevcache[y] != cache[y]) {
            for (c = 0; c < 4; c++) {
                if (cache[y] >> (24 - (c * 8)) != prevcache[y] >> (24 - (c * 8)))
                    SPI_SendRegData(7 - c, 16 - y, (unsigned char) (cache[y] >> (24 - (c * 8))));
            }

            prevcache[y] = cache[y];
        }
}

void DrawCharacter(char x, char y, char c) {

    unsigned char i;

    for (i = 0; i < 15; i++)
        SetPixel(x + i % 3, y + i / 3, c == ' ' ? 0 : (((c <= '9' ? numbers[c - '0'] : letters[c - 'A']) >> (14 - i)) & 0x01));
}

void DrawString(char x, char y, const char* str) {

    unsigned char position = 0;

    do {
        DrawCharacter(x + (position++ * 4), y, *str);
    } while (*++str != 0);

};

void ShowNumber(char x, char y, unsigned char number) {

DrawCharacter(x, y, '0' + number);

    /*for (c = 0; c < 3; c++) {
        SetPixel(x + c, y - 1, 0);
        SetPixel(x + c, y + 5, 0);
    }*/

    /*unsigned char c;

    

    for (c = 0; c < 15; c++) {
        SetPixel(x + (c % 3), y + (c / 3), (numbers[number] >> (15 - c)) & 0x0001);
    }*/
}

void ShiftNumber(unsigned char x, unsigned char y, unsigned char from, unsigned char to, direction dir) {

    char y2;

    if (dir == up) {

        for (y2 = 7; y2 >= 0; y2--) {
            ShowNumber(x, y - y2, to);
            ShowNumber(x, (7 + y) - y2, from);
            pause(); //pause();pause();
        }

    } else
        for (y2 = 0; y2 < 8; y2++) {
            ShowNumber(x, y - y2, from);
            ShowNumber(x, (7 + y) - y2, to);
            pause(); //pause();pause();
        }
}

void ShiftNumberY(char y2, unsigned char x, unsigned char y, unsigned char from, unsigned char to, direction dir) {
    switch (dir) {
        case up:
            //ShowNumber(x, y, from);
            //ShowNumber(x, y, to);

            DrawCharacter(x, y, '0' + to);

            break;
        case down:
            //ShowNumber(x, y - y2, from);

            if (y2 < 8)
                ShowNumber(x, y - y2, from);
            else
                ShowNumber(x, y - (13 - y2), to);

            break;
    }
}

//unsigned char lasthour = 99, lastminute = 99, lastsecond = 99;

DateTime* lastDateTime = new DateTime(99, 99, 99, 99, 99, 99);

/*void ShowTime(unsigned char hour, unsigned char minute, unsigned char second)
{
    char c, x;

    if (lasthour != hour) {
    ShowNumber(1+0,1, hour / 10);
    ShowNumber(1+4,1, hour % 10);

    SetPixel(1+4+4,1,1);
    SetPixel(1+4+4,5,1);
    }

    if (lastminute != minute) {
    ShowNumber(1+4+4+2,1, minute / 10);
    ShowNumber(1+4+4+2+4,1, minute % 10);

    SetPixel(1+4+4+2+4+4,1,1);
    SetPixel(1+4+4+2+4+4,5,1);
    }

    if (lastsecond/10 != second/10 && lastsecond%10 != second%10) {
        for (c = 0; c < 8; c++) {
            ShiftNumberY(c, 1+4+4+2+2+4+4,1,lastsecond / 10, second / 10, up);
            ShiftNumberY(c, 1+4+4+2+2+4+4+4,1,lastsecond % 10, second % 10, up);
            pause();
        }
    }
    else {

    if (lastsecond/10 != second/10)
        ShiftNumber(1+4+4+2+2+4+4,1,lastsecond / 10, second / 10);

    if (lastsecond%10 != second%10)
        ShiftNumber(1+4+4+2+2+4+4+4,1,lastsecond % 10, second % 10, up);

    }

    //ShowNumber(4+4+2+2+4+4,0, second / 10);
    //ShowNumber(4+4+2+2+4+4+4,0, second % 10);

    lasthour = hour; lastminute = minute; lastsecond = second;


}*/

void Delay(unsigned int ticks) {

    WriteTimer1(0);
    while (ReadTimer1() < ticks) Nop();
}

void DrawDate(DateTime::DateTimeData dt) {

    unsigned char x = 3;

    if (dt.day / 10 != 0) {
        ShowNumber(x, 9, dt.day / 10);
        x += 5;
    }

    ShowNumber(x, 9, dt.day % 10);

    x += 6;

    DrawString(x, 9, months[dt.month - 1]);
}

void DrawSeparator(bool on) {
    SetPixel(STARTCOLUMN + 4 + 4, TIMEROW + 1, on);
    SetPixel(STARTCOLUMN + 4 + 4, TIMEROW + 3, on);
    SetPixel(STARTCOLUMN + 4 + 4 + 2 + 4 + 4, TIMEROW + 1, on);
    SetPixel(STARTCOLUMN + 4 + 4 + 2 + 4 + 4, TIMEROW + 3, on);
}

bool ShowTimeSlide(DateTime* dateTime) {
    char c, x;

    /*SetPixel(1+4+4,1,0);
    SetPixel(1+4+4,5,0);
    SetPixel(1+4+4+2+4+4,1,0);
    SetPixel(1+4+4+2+4+4,5,0);*/

    //if (lastDateTime.hour == 99)
    {


        //   SetPixel(STARTCOLUMN + 4 + 4, DATEROW + 4, 1);
        //        SetPixel(STARTCOLUMN + 4 + 4 + 2 + 4 + 4, DATEROW + 4, 1);

    }

    if (!lastDateTime->Equals(dateTime)) {

        direction dir = dateTime->GetDateTime().second % 2 == 0 ? up : down;

        for (c = 13; c < 14; c++) {

            WriteTimer1(0);


            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().hour / 10 != lastDateTime->GetDateTime().hour / 10) ShowNumber(STARTCOLUMN + 0, TIMEROW, dateTime->GetDateTime().hour / 10);
            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().hour % 10 != lastDateTime->GetDateTime().hour % 10) ShowNumber(STARTCOLUMN + 4, TIMEROW, dateTime->GetDateTime().hour % 10);

            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().minute / 10 != lastDateTime->GetDateTime().minute / 10) ShowNumber(STARTCOLUMN + 4 + 4 + 2, TIMEROW, dateTime->GetDateTime().minute / 10);
            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().minute % 10 != lastDateTime->GetDateTime().minute % 10) ShowNumber(STARTCOLUMN + 4 + 4 + 2 + 4, TIMEROW,  dateTime->GetDateTime().minute % 10);

            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().second / 10 != lastDateTime->GetDateTime().second / 10) ShowNumber(STARTCOLUMN + 4 + 4 + 2 + 2 + 4 + 4, TIMEROW, dateTime->GetDateTime().second / 10);
            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().second % 10 != lastDateTime->GetDateTime().second % 10) ShowNumber(STARTCOLUMN + 4 + 4 + 2 + 2 + 4 + 4 + 4, TIMEROW,  dateTime->GetDateTime().second % 10);

            /*if (lastDateTime->GetDateTime().hour == 99 || (dateTime->GetDateTime().year - 2000) / 10 != (lastDateTime->GetDateTime().year - 2000) / 10) ShiftNumberY(c, STARTCOLUMN + 0, DATEROW, (lastDateTime->GetDateTime().year - 2000) / 10, (dateTime->GetDateTime().year - 2000) / 10, up);
            if (lastDateTime->GetDateTime().hour == 99 || (dateTime->GetDateTime().year - 2000) % 10 != (lastDateTime->GetDateTime().year - 2000) % 10) ShiftNumberY(c, STARTCOLUMN + 4, DATEROW, (lastDateTime->GetDateTime().year - 2000) % 10, (dateTime->GetDateTime().year - 2000) % 10, up);

            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().month / 10 != lastDateTime->GetDateTime().month / 10) ShiftNumberY(c, STARTCOLUMN + 4 + 4 + 2, DATEROW, lastDateTime->GetDateTime().month / 10, dateTime->GetDateTime().month / 10, up);
            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().month % 10 != lastDateTime->GetDateTime().month % 10) ShiftNumberY(c, STARTCOLUMN + 4 + 4 + 2 + 4, DATEROW, lastDateTime->GetDateTime().month % 10, dateTime->GetDateTime().month % 10, up);

            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().day / 10 != lastDateTime->GetDateTime().day / 10) ShiftNumberY(c, STARTCOLUMN + 4 + 4 + 2 + 2 + 4 + 4, DATEROW, lastDateTime->GetDateTime().day / 10, dateTime->GetDateTime().day / 10, up);
            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().day % 10 != lastDateTime->GetDateTime().day % 10) ShiftNumberY(c, STARTCOLUMN + 4 + 4 + 2 + 2 + 4 + 4 + 4, DATEROW, lastDateTime->GetDateTime().day % 10, dateTime->GetDateTime().day % 10, up);*/

            if (lastDateTime->GetDateTime().day != dateTime->GetDateTime().day)
                DrawDate(dateTime->GetDateTime());

            SendToModules();

            while (ReadTimer1() < 500 + (c * 100)) Nop();
            //pause();pause();pause();
        }

        lastDateTime->Copy(dateTime);

        return true;
    }
    return false;
}

bool ShowTime(DateTime* dateTime) {
    if (!lastDateTime->Equals(dateTime)) {

            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().hour / 10 != lastDateTime->GetDateTime().hour / 10) ShowNumber(STARTCOLUMN + 0, TIMEROW, dateTime->GetDateTime().hour / 10);
            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().hour % 10 != lastDateTime->GetDateTime().hour % 10) ShowNumber(STARTCOLUMN + 4, TIMEROW, dateTime->GetDateTime().hour % 10);

            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().minute / 10 != lastDateTime->GetDateTime().minute / 10) ShowNumber(STARTCOLUMN + 4 + 4 + 2, TIMEROW, dateTime->GetDateTime().minute / 10);
            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().minute % 10 != lastDateTime->GetDateTime().minute % 10) ShowNumber(STARTCOLUMN + 4 + 4 + 2 + 4, TIMEROW,  dateTime->GetDateTime().minute % 10);

            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().second / 10 != lastDateTime->GetDateTime().second / 10) ShowNumber(STARTCOLUMN + 4 + 4 + 2 + 2 + 4 + 4, TIMEROW, dateTime->GetDateTime().second / 10);
            if (lastDateTime->GetDateTime().hour == 99 || dateTime->GetDateTime().second % 10 != lastDateTime->GetDateTime().second % 10) ShowNumber(STARTCOLUMN + 4 + 4 + 2 + 2 + 4 + 4 + 4, TIMEROW,  dateTime->GetDateTime().second % 10);

            if (lastDateTime->GetDateTime().day != dateTime->GetDateTime().day)
                DrawDate(dateTime->GetDateTime());

            lastDateTime->Copy(dateTime);
    }
}

unsigned int GetPhotocellValue() {
    return ReadADC10(8 * ((~ReadActiveBufferADC10() & 0x01)));
}

unsigned char lastStrength = 0;

char GetUartChar() {

    unsigned short timer = 0;

    while (!DataRdyUART1() && timer++ < 0xffff);

    if (timer == 0xffff)
        return 0;

    return ReadUART1();
}

extern "C"


void InitUart() {

    CloseUART1();
    U1RXR = 0b0010; // U1RX = A4
    PORTSetPinsDigitalIn(IOPORT_A, BIT_4);
    //ConfigIntUART1(UART_RX_INT_EN);

    IEC1bits.U1RXIE = 1; //Enables RX interrupt.
    IFS1bits.U1RXIF = 0; //Clears RX interrupt flag.
    IPC8bits.U1IP = 7;
    IPC8bits.U1IS = 3;


    OpenUART1(UART_EN | UART_NO_PAR_8BIT | UART_1STOPBIT | UART_DIS_ABAUD, UART_RX_ENABLE | UART_RX_OVERRUN_CLEAR | UART_ADR_DETECT_DIS | UART_RX_ENABLE, 51);
    INTConfigureSystem(INT_SYSTEM_CONFIG_MULT_VECTOR);
    // Configure UART2 RX Interrupt
    /*INTEnable(INT_SOURCE_UART_RX(UART1), INT_ENABLED);
    INTSetVectorPriority(INT_VECTOR_UART(UART1), INT_PRIORITY_LEVEL_2);
    INTSetVectorSubPriority(INT_VECTOR_UART(UART1), INT_SUB_PRIORITY_LEVEL_0);

    INTConfigureSystem(INT_SYSTEM_CONFIG_MULT_VECTOR);

    INTEnableInterrupts();*/
}

DateTime::DateTimeData GetDateTime() {

    DateTime::DateTimeData returnDateTime;

    U1STAbits.URXEN = 1;

    unsigned char rc;
    unsigned short i;

    char GPx[6];

    do {
        rc = GetUartChar();

        if (rc == '$') {

            GPx[5] = 0x00;

            getsUART1(6, GPx, 0xffff);

            if (strcmp(GPx, "GPRMC,") == 0) {
                getsUART1(6, GPx, 0xffff);

                returnDateTime.hour = ((GPx[0] - '0') * 10) + (GPx[1] - '0');
                returnDateTime.minute = ((GPx[2] - '0') * 10) + (GPx[3] - '0');
                returnDateTime.second = ((GPx[4] - '0') * 10) + (GPx[5] - '0');

                i = 0;

                while (i < 8) {
                    if (GetUartChar() == ',') i++;
                }

                getsUART1(6, GPx, 0xffff);

                returnDateTime.day = ((GPx[0] - '0') * 10) + (GPx[1] - '0');
                returnDateTime.month = ((GPx[2] - '0') * 10) + (GPx[3] - '0');
                returnDateTime.year = ((GPx[4] - '0') * 10) + (GPx[5] - '0') + 2000;

                //if (++returnDateTime.hour>24) returnDateTime.hour = 0;
                //returnDateTime.hour = (returnDateTime.hour+2)%25;

                return returnDateTime;
            }
        }

        //UARTSendDataByte(UART1,rc);

        //WriteUART1(rc);

        /*if (i > 9) i = 0;

        UARTSendDataByte(UART1,'0'+i++);*/

        // while(!UARTTransmissionHasCompleted(UART1));

        //while(U1STAbits.TRMT == 0);
        //    while (BusyUART1());
    } while (1);

}

void SetLedStrength() {
    unsigned int x;
    unsigned char i;
    unsigned int sum = 0;

    for (i = 0; i < 20; i++) {

        x = GetPhotocellValue();

        if (x > 900)
            x = 900;

        if (x > 100) x -= 100;
        else x = 0;

        x /= 53;

        sum += x;
    }

    x = sum / 20;

    if (x != lastStrength) {
        lastStrength = x;

        for (x = 0; x < 8; x++) {
            SPI_Send(x, 0x0a00 | (lastStrength > 0x0f ? 0x0f : lastStrength));
        }
    }
}
ds3232 ds;

int main() {

    SYSTEMConfig(SYS_FREQ, SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE);
    mJTAGPortEnable(DEBUG_JTAGPORT_OFF);

    OpenTimer1(T1_ON | T1_PS_1_256, 0xffff);

    WriteTimer1(0);

    while (ReadTimer1() < 0xfff) Nop();

    //ClearWDT();
    //ClearEventWDT();

    unsigned int k = 2;

    for (k = 0; k < ROWS; k++)
        prevcache[k] = 0xffffffff;


    /*INTDisableInterrupts();
    mCNAOpen(CNA_ON | CNB_IDLE_CON, CNA2_ENABLE, CNA_PULLUP_DISABLE_ALL);

    int tempPortRead = mPORTARead();

    INTEnable(INT_CNA, INT_ENABLED);
    INTSetVectorPriority(INT_CHANGE_NOTICE_VECTOR, INT_PRIORITY_LEVEL_2);
    INTEnableSystemMultiVectoredInt();*/
    ds.Init();
    //offset = ds.GetInt();
    //ds.Init();



    //iii = ds.GetInt();*/

    //SPI1BRG = 0;

    //SpiOpenFlags    oFlags;
    //oFlags = SPICON_ON|SPICON_MSTEN|SPICON_CKP|SPICON_SMP|SPICON_MODE16;

    //SpiChnOpen(SPI_CHANNEL1,oFlags, k);


    //CloseADC10();

    // define setup parameters for OpenADC10
#define PARAM1 ADC_MODULE_ON | ADC_FORMAT_INTG | ADC_CLK_AUTO | ADC_AUTO_SAMPLING_ON
#define PARAM2 ADC_VREF_AVDD_AVSS | ADC_OFFSET_CAL_DISABLE | ADC_SCAN_OFF | ADC_SAMPLES_PER_INT_2 | ADC_ALT_BUF_ON | ADC_ALT_INPUT_ON
#define PARAM3 ADC_CONV_CLK_INTERNAL_RC | ADC_SAMPLE_TIME_12
#define PARAM4 SKIP_SCAN_ALL
#define PARAM5 ENABLE_AN4_ANA
    // configure to sample AN4 & AN5
    SetChanADC10(ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEA_AN4);
    // configure ADC and enable it
    OpenADC10(PARAM1, PARAM2, PARAM3, PARAM4, PARAM5);
    // Now enable the ADC logic
    EnableADC10();


    OpenSPI1(SPI_MODE16_ON | SPI_SMP_ON | SPI_CKE_ON | MASTER_ENABLE_ON | SEC_PRESCAL_1_1 | PRI_PRESCAL_1_1, SPI_ENABLE);

    RPB13R = 0b0011; // SET RB13 = SDO
    TRISAbits.TRISA2 = 1;
    TRISBbits.TRISB3 = 0;
    TRISBbits.TRISB5 = 0;
    TRISBbits.TRISB15 = 0;


    unsigned char y;
    unsigned char x;

    for (x = 0; x < 8; x++) {
        SPI_Send(x, 0x0100 + 0x0001);
        SPI_Send(x, 0x0C01);
        SPI_Send(x, 0x0900);
        SPI_Send(x, 0x0b0f);
        SPI_Send(x, 0x0a0F);

        for (y = 0; y < 8; y++)
            SPI_SendRegData(x, 8 - y, 0x00);
    }

    for (x = 0; x < ROWS; x++) {
        prevcache[x] = 0xffff;
        cache[x] = 0x00;
    }


    /*SetPixel(0,0,1);
    SetPixel(8+1,0,1);
    SetPixel(16+2,0,1);
    SetPixel(24+3,0,1);
    SetPixel(0+1,8,1);
    SetPixel(8+2,8,1);
    SetPixel(16+3,8,1);
    SetPixel(24+4,8,1);
    SendToModules();
    while (1) {

    }*/

    //ShowTime(12,34,56);

    //ShowTime(12,34,56);
    //while(1);

    //I2C1CONbits.SMEN = 1;




    //    x = DS3232_OE.data;


    unsigned char sec, minute, hour;

    char temp;


    // PORTB10 and PORTB11 is configured as digital inputs
    PORTSetPinsDigitalIn(IOPORT_B, BIT_10 | BIT_11);
    // Want to detect PORTB10 and PORTB11 change. Switch grounds the pin when pressed, therefor pullups
    mCNBOpen(CNB_ON | CNB_IDLE_CON, CNB10_ENABLE | CNB11_ENABLE, CNB10_PULLUP_ENABLE | CNB11_PULLUP_ENABLE);
    // Clear mismatch condition
    mPORTBRead();
    // Want interrupt to trigger when pin pulled to ground
    ConfigIntCNB(CHANGE_INT_ON | CHANGE_INT_PRI_2 | FALLING_EDGE_INT);





    /*dt.year = 14;
    dt.month = 3;
    dt.day = 30;
    dt.hour = 18;
    dt.minute = 0;
    dt.second = 0;

    ds.SetDateTime(dt);*/

    DateTime::DateTimeData dt, dt2;

    unsigned short c;

    do {
        dt2 = ds.GetDateTime();
    } while (dt2.second == dt.second);

    WriteTimer1(0);

    do {
        dt = ds.GetDateTime();
    } while (dt2.second == dt.second);

    second = ReadTimer1();

    temp = 0;
    unsigned int i = 0;
    ShowTime(new DateTime(2001, 2, 3, 4, 5, 6));

    InitUart();

    // Enable multi-vector interrupts
    INTEnableSystemMultiVectoredInt();

    while (1) {

        // dt = ds.GetDateTime();

        //dt.year = PORTBbits.RB10;
        //dt.month = PORTBbits.RB11;
        //        dt.day = click;

        /*  DateTime gps(GetDateTime());
          gps.AddHours(1);
          gps.AddHours(gps.IsSwedishSummerTime() ? 1 : 0);
          DrawSeparator(gps.GetDateTime().second % 2);
          ShowTimeSlide(&gps);
          SetLedStrength();*/

        /*if (!IFS1bits.U2RXIF) {
            SetLedStrength();
            WriteTimer1(0);
            while (ReadTimer1() < second / 10) Nop();
        }*/

        /*for (i = 0; i < 4; i++) {
        DrawSeparator(i == 2 || i == 3);
        SendToModules();
        while (ReadTimer1() < tick / 4) Nop();
        }*/

        //while (ReadTimer1() < tick) Nop();

        /*if (!LATAbits.LATA4) {
                     SetPixel(temp, 7, 0);
                    if (temp < 32) temp++; else temp = 0;
                    SetPixel(temp, 7, 1);
                    SendToModules();
         *
        }*/

        //while(1);
    }
    return 0;
}

/*extern "C"
void __ISR(_CHANGE_NOTICE_VECTOR, IPL2SOFT) ChangeNotice_Handler(void)
{
    int tempPortRead = PORTA; // clear port mismatch
    IFS1CLR = 0x2000; //CLEAR CNA Interrupt FLAG
    IFS0CLR = 0x0008; //CLEAR External Interrupt FLAG

}*/

char temp = 0;

extern "C" // Should be removed if not C++

void __ISR(_CHANGE_NOTICE_VECTOR, IPL2SOFT) ChangeNotice_Handler(void) {
    unsigned int portb;
    unsigned int debounce = 0;
    unsigned int debounceCount = 0;

    // clear the mismatch condition and store PORTB value
    portb = mPORTBRead();

    // clear interrupt flag
    mCNBClearIntFlag();

    // Debouncing. Modify as see fit
    do {
        if (!PORTBbits.RB10 || !PORTBbits.RB11) debounceCount++;
    } while (debounce++ < 0xffff);

    // Not enough low time. Do nothing
    if (debounceCount < 0xfff)
        return;

    if (!(portb & (0x01 << 10)))
        click += 1;

    if (!(portb & (0x01 << 11)))
        click += 10;


    if (click > 99) click = 0;
}

// extern "C"
//
// void __ISR(_TIMER_1_VECTOR, ipl2) _Timer1Handler(void)
//{
//
//         mT1ClearIntFlag();
//
//       /*  SetPixel(temp, 7, 0);
//        if (temp < 32) temp++; else temp = 0;
//        SetPixel(temp, 7, 1);
//        SendToModules();*/
//
//// clear the interrupt flag
//
// }

// UART 2 interrupt handler
// it is set at priority level 2 with software context saving


unsigned xx = 0;

extern "C"
void __ISR(_UART1_VECTOR, IPL7SOFT) CommunicationHandler(void) {

    DateTime gps(GetDateTime());
    gps.AddHours(1);
    gps.AddHours(gps.IsSwedishSummerTime() ? 1 : 0);
    DrawSeparator(gps.GetDateTime().second % 2);
    ShowTime(&gps);
    SendToModules();
    SetLedStrength();
    IFS1bits.U2RXIF = 0;
}

